import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { PositionalArguments } from './PositionalArguments.js';
export class PositionalArgumentsDeclaration {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.PositionalArgumentsDeclaration;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.arguments = new PositionalArguments(ast.arguments, offsets[0], options);
        metadata = updateMetadata(metadata, [this.arguments]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['(', path.call(print, 'arguments'), ')'];
    }
}
//# sourceMappingURL=PositionalArgumentsDeclaration.js.map