import { doc } from 'prettier';
import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { SourceUnitMembers } from './SourceUnitMembers.js';
const { line } = doc.builders;
export class SourceUnit {
    constructor(ast, offset, options) {
        this.kind = NonterminalKind.SourceUnit;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.members = new SourceUnitMembers(ast.members, offsets[0], options);
        metadata = updateMetadata(metadata, [this.members]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print, options) {
        return [path.call(print, 'members'), options.parentParser ? '' : line];
    }
}
//# sourceMappingURL=SourceUnit.js.map