import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { VersionExpression } from './VersionExpression.js';
export class VersionComparator {
    constructor(ast, offset) {
        this.kind = NonterminalKind.VersionComparator;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.operator = ast.operator.text;
        this.operand = new VersionExpression(ast.operand, offsets[0]);
        metadata = updateMetadata(metadata, [this.operand]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [this.operator, path.call(print, 'operand')];
    }
}
//# sourceMappingURL=VersionComparator.js.map