import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { VersionExpression } from './VersionExpression.js';
export class VersionRange {
    constructor(ast, offset) {
        this.kind = NonterminalKind.VersionRange;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.leftOperand = new VersionExpression(ast.leftOperand, offsets[0]);
        this.operator = ast.operator.text;
        this.rightOperand = new VersionExpression(ast.rightOperand, offsets[1]);
        metadata = updateMetadata(metadata, [this.leftOperand, this.rightOperand]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return [
            path.call(print, 'leftOperand'),
            ` ${this.operator} `,
            path.call(print, 'rightOperand')
        ];
    }
}
//# sourceMappingURL=VersionRange.js.map