import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { TerminalNode } from '@nomicfoundation/slang/cst/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { YulColonAndEqual } from './YulColonAndEqual.js';
export class YulAssignmentOperator {
    constructor(ast, offset) {
        this.kind = NonterminalKind.YulAssignmentOperator;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.variant =
            ast.variant instanceof TerminalNode
                ? ast.variant.text
                : new YulColonAndEqual(ast.variant, offsets[0]);
        metadata = updateMetadata(metadata, typeof this.variant === 'string' ? [] : [this.variant]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return typeof this.variant === 'string'
            ? this.variant
            : path.call(print, 'variant');
    }
}
//# sourceMappingURL=YulAssignmentOperator.js.map